#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#include "ECA_MemAlloc.h"
#include "MathStatRand.h"

#include "MDL_Blocks.h"



arch_struct *AllocArchStruct(int NumSeq, int NumTips, int NumMarkers)
{
	int i;
	arch_struct *temp = (arch_struct *)ECA_MALLOC(sizeof(arch_struct));
	
	temp->NumTips = 0;
	temp->NumSeq = NumSeq;
	temp->Length = 0;
	temp->MaxNumTips = NumTips;
	
	temp->TheTipSeqs = (int **)ECA_CALLOC( (size_t)NumTips, sizeof(int *));
	temp->Diffs = (int **)ECA_CALLOC( (size_t)NumTips, sizeof(int *));
	for(i=0;i<NumTips;i++)  {
		temp->TheTipSeqs[i] = (int *)ECA_CALLOC( (size_t)NumMarkers, sizeof(int) );
		temp->Diffs[i] = (int *)ECA_CALLOC( (size_t)NumSeq, sizeof(int));
	}
	
	temp->ASet = (int *)ECA_CALLOC( (size_t)NumSeq, sizeof(int));
	temp->PASet = (int *)ECA_CALLOC( (size_t)NumSeq, sizeof(int));
	temp->MinMs = (int *)ECA_CALLOC( (size_t)NumSeq, sizeof(int));
	temp->PMinMs = (int *)ECA_CALLOC( (size_t)NumSeq, sizeof(int));
	
	return(temp);
}


void FreeArchStruct(arch_struct *A)
{
	int i;
	for(i=0;i<A->MaxNumTips;i++)  {
		free(A->TheTipSeqs[i]);
		free(A->Diffs[i]);
	}
	free(A->TheTipSeqs);
	free(A->Diffs);
	
	free(A->ASet);
	free(A->PASet);
	free(A->MinMs);
	free(A->PMinMs);
	
	free(A);
	
}


// to transfer the necessary info from B over to A for a block
// starting at a and ending at b inclusive.  Sort of messy because of the way all
// this has been stored, etc.
void TransferToArch(arch_struct *A, MDL_struct *B, int NumTips, int a, int b)
{
	int i,j,k,NumDiffs;
	// first store the simple ints:
	A->NumTips = NumTips;
	A->NumSeq = B->NumSeq;
	A->Length = b - a + 1;
	
	// then, store the sequences.  These should have been ordered
	// by number of visits (just for convenience, really)
	for(i=0;i<NumTips;i++)  {
		for(j=0;j<A->Length;j++)  {
			A->TheTipSeqs[i][j] = B->TipSeqs[B->Tips[i]->Idx][j];
		}
	}
	
	// now that we have those, we should count up the diffs for all of these.  Not a hard task:
	for(i=0;i<NumTips;i++)  {
		for(j=0;j<A->NumSeq;j++)  {
			NumDiffs = 0;
		 	for(k=0;k<A->Length;k++)  {
		 		if( B->Yobs[j][a+k] >= 0   &&   B->Yobs[j][a+k] != A->TheTipSeqs[i][k]) {
		 			NumDiffs++;
		 		}
		 	}
		 	A->Diffs[i][j] = NumDiffs;
		}
	}
}

// just a little thing to print this out
void PrintArchStruct(arch_struct *A, char *FileName, int a, int b)
{
	int i,j,M=10;
	FILE *out = fopen(FileName,"w");
	
	fprintf(out,"NumTips: %d\nNumSeq: %d\nLength: %d\n",A->NumTips,A->NumSeq,A->Length);
	fprintf(out,"a: %d  b: %d",a,b);
	
	for(i=0;i<A->NumTips;i++)  {
		fprintf(out,"\n\n\n");
		for(j=0;j<A->Length;j++)  {  // print out the sequence of the tip.
			fprintf(out,"%d",A->TheTipSeqs[i][j]);
		}
		
		// then print out the seq diffs
		for(j=0;j<A->NumSeq;j++)  {
			if(j%M == 0) {
				fprintf(out,"\n[%d]\t",j);
			}
				fprintf(out,"\t%d",A->Diffs[i][j]);
		}
	}
	fclose(out);	
}

void ScoreOfProposedArch(arch_struct *A)
{
	
}

// this finds, in a greedy fashion, a small number of archetypal seqs that
// minimizes some score.
void GreedyFindArch(arch_struct *A)
{
	
	// first find the best initial archetype
	
	
	// given a proposed set of archs, compute the score

	
}





















